<?php

    namespace Modules\Lpj\Http\Controllers;

    use App\Http\Controllers\Controller;
    use Exception;
    use Illuminate\Http\Request;
    use Maatwebsite\Excel\Facades\Excel;
    use Modules\Lpj\Exports\JenisLegalitasJaminanExport;
    use Modules\Lpj\Http\Requests\JenisLegalitasJaminanRequest;
    use Modules\Lpj\Models\CustomField;
    use Modules\Lpj\Models\JenisLegalitasJaminan;

    class JenisLegalitasJaminanController extends Controller
    {
        public $user;

        public function index()
        {
            return view('lpj::jenis_legalitas_jaminan.index');
        }

        public function store(JenisLegalitasJaminanRequest $request)
        {
            $validate = $request->validated();

            if ($validate) {
                try {
                    // Save to database
                    JenisLegalitasJaminan::create($validate);
                    return redirect()
                        ->route('basicdata.jenis-legalitas-jaminan.index')
                        ->with('success', 'Jenis Legalitas Jaminan created successfully');
                } catch (Exception $e) {
                    return redirect()
                        ->route('basicdata.jenis-legalitas-jaminan.create')
                        ->with('error', 'Failed to create jenis legalitas jaminan');
                }
            }
        }

        public function create()
        {
            $customFields = CustomField::orderBy('urutan_prioritas', 'asc')->get();
            return view('lpj::jenis_legalitas_jaminan.create',compact('customFields'));
        }

        public function edit($id)
        {
            $jenisLegalitasJaminan = JenisLegalitasJaminan::find($id);
            $customFields = CustomField::orderBy('urutan_prioritas', 'asc')->get();
            return view('lpj::jenis_legalitas_jaminan.create', compact('jenisLegalitasJaminan', 'customFields'));
        }

        public function update(JenisLegalitasJaminanRequest $request, $id)
        {
            $validate = $request->validated();

            if ($validate) {
                try {
                    // Update in database
                    $jenisLegalitasJaminan = JenisLegalitasJaminan::find($id);
                    $jenisLegalitasJaminan->update($validate);
                    return redirect()
                        ->route('basicdata.jenis-legalitas-jaminan.index')
                        ->with('success', 'Jenis Legalitas Jaminan updated successfully');
                } catch (Exception $e) {
                    return redirect()
                        ->route('basicdata.jenis-legalitas-jaminan.edit', $id)
                        ->with('error', 'Failed to update jenis legalitas jaminan');
                }
            }
        }

        public function destroy($id)
        {
            try {
                // Delete from database
                $jenisLegalitasJaminan = JenisLegalitasJaminan::find($id);
                $jenisLegalitasJaminan->delete();

                echo json_encode(['success' => true, 'message' => 'Jenis Legalitas Jaminan deleted successfully']);
            } catch (Exception $e) {
                echo json_encode(['success' => false, 'message' => 'Failed to delete jenis legalitas jaminan']);
            }
        }

        public function dataForDatatables(Request $request)
        {
            if (is_null($this->user) || !$this->user->can('jenis_legalitas_jaminan.view')) {
                //abort(403, 'Sorry! You are not allowed to view users.');
            }

            // Retrieve data from the database
            $query = JenisLegalitasJaminan::query();

            // Apply search filter if provided
            if ($request->has('search') && !empty($request->get('search'))) {
                $search = $request->get('search');
                $query->where(function ($q) use ($search) {
                    $q->where('code', 'LIKE', "%$search%");
                    $q->orWhere('name', 'LIKE', "%$search%");
                });
            }

            // Apply sorting if provided
            if ($request->has('sortOrder') && !empty($request->get('sortOrder'))) {
                $order  = $request->get('sortOrder');
                $column = $request->get('sortField');
                $query->orderBy($column, $order);
            }

            // Get the total count of records
            $totalRecords = $query->count();

            // Apply pagination if provided
            if ($request->has('page') && $request->has('size')) {
                $page   = $request->get('page');
                $size   = $request->get('size');
                $offset = ($page - 1) * $size; // Calculate the offset

                $query->skip($offset)->take($size);
            }

            // Get the filtered count of records
            $filteredRecords = $query->count();

            // Get the data for the current page
            $data = $query->get();

            // Calculate the page count
            $pageCount = ceil($totalRecords / $request->get('size'));

            // Calculate the current page number
            $currentPage = 0 + 1;

            // Return the response data as a JSON object
            return response()->json([
                'draw'            => $request->get('draw'),
                'recordsTotal'    => $totalRecords,
                'recordsFiltered' => $filteredRecords,
                'pageCount'       => $pageCount,
                'page'            => $currentPage,
                'totalCount'      => $totalRecords,
                'data'            => $data,
            ]);
        }

        public function export()
        {
            return Excel::download(new JenisLegalitasJaminanExport, 'jenis_legalitas_jaminan.xlsx');
        }

        public function getCustomFields($id)
        {
            $jenisLegalitasJaminan = JenisLegalitasJaminan::findOrFail($id);
            if(!$jenisLegalitasJaminan->custom_fields) {
                return response()->json([]);
            }
            
            $customFields = CustomField::whereIn('id', $jenisLegalitasJaminan->custom_fields)->get();

            return response()->json($customFields);
        }
    }
